Index: /trunk/gsdl/perllib/classify/HFileHierarchy.pm
===================================================================
--- /trunk/gsdl/perllib/classify/HFileHierarchy.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/HFileHierarchy.pm	(revision 10218)
@@ -51,9 +51,4 @@
 	'type' => "flag",
 	'reqd' => "no" },
-      { 'name' => "sort",
-	'desc' => "{Hierarchy.sort}",
-	'type' => "string",
-	'deft' => "{BasClas.metadata.deft}",
-	'reqd' => "no" },
       { 'name' => "hfile",
 	'desc' => "{Hierarchy.hfile}",
@@ -69,5 +64,5 @@
 	'desc' => "{Hierarchy.sort}",
 	'type' => "string",
-	'deft' => "{BasClas.metadata.deft}", 
+#	'deft' => "{BasClas.metadata.deft}", 
 	'reqd' => "no" },
       { 'name' => "reverse_sort",
@@ -82,5 +77,5 @@
 my $options = 
 { 	'name'     => "HFileHierarchy",
-	'desc'     => "{Hierarchy.desc}",
+	'desc'     => "{HFileHierarchy.desc}",
 	'abstract' => "yes",
 	'inherits' => "yes", 
@@ -89,37 +84,14 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
- 
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
- 
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
- 
-    my ($hfile, $metadata, $buttonname, $sortname, $reverse_sort, $title, 
-	$hlist_at_top);
-    my $firstvalueonly = 0;
-    my $allvalues = 0;
-    
-    if (!parsargv::parse(\@_, 
-			 q^metadata/.*/^, \$metadata,
-			 q^buttonname/.*/^, \$buttonname,
-			 q^firstvalueonly^, \$firstvalueonly,
-			 q^allvalues^, \$allvalues,
-			 q^sort/.*/^, \$sortname,
-			 q^reverse_sort^, \$reverse_sort,
-			 q^hfile/.*/^, \$hfile,
-			 q^hlist_at_top^, \$hlist_at_top,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-
-    }
-
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs); 
+
+    my $metadata = $self->{'metadata'};
     if (!$metadata) {
 	print STDERR "$class Error: required option -metadata not supplied\n";
@@ -129,11 +101,15 @@
     }
     
-    $buttonname = $self->generate_title_from_metadata($metadata) unless ($buttonname);
-    $title = $buttonname;
-    $self->{'title'} = $title;
-
-    $self->{'metaname'} = $metadata;
+    $self->{'buttonname'} = $self->generate_title_from_metadata($metadata) unless ($self->{'buttonname'});
+
+    #$self->{'metaname'} = $metadata;
     my @meta_list = split(/,/, $metadata);
     $self->{'meta_list'} = \@meta_list;
+
+    print STDERR "sort = $self->{'sort'}\n";
+    # sort = undef in this case is the same as sort=nosort
+    if ($self->{'sort'} eq "nosort") {
+	$self->{'sort'} = undef;
+    }
 
     # sortname is handled a bit differently - kjdon
@@ -142,18 +118,21 @@
     # we have a list of possible metadata.
     # To get no sorting, set sortname = 'nosort'
-    if (!$sortname) {
-	if (defined ($metadata)) {
-	    $sortname = undef;
-	} else {
-	    $sortname = "nosort";
-	}
-    }
-    $self->{'sortname'} = $sortname;
-
-    if (defined $sortname && $reverse_sort) {
-	$self->{'reverse_sort'} = 1;
-    }
+    # we don't need to set it to undef if its not defined do we???
+
+#    if (!$self->{'sort'}) {
+#	if (defined ($metadata)) {
+#	    $sortname = undef;
+#	} else {
+#	    $sortname = "nosort";
+#	}
+#    }
+ #   $self->{'sortname'} = $sortname;
+
+    #if (defined $self->{'sort'} && $reverse_sort) {
+#	$self->{'reverse_sort'} = 1;
+ #   }
 	
-    if ($hfile) {
+    if ($self->{'hfile'}) {
+	my $hfile = $self->{'hfile'};
 	my $subjectfile;
 	$subjectfile = &util::filename_cat($ENV{'GSDLCOLLECTDIR'},"etc", $hfile);
@@ -177,9 +156,12 @@
     
 
-    $self->{'firstvalueonly'} = $firstvalueonly;
-    $self->{'allvalues'} = $allvalues;
-
-    $self->{'hlist_at_top'} = $hlist_at_top;
-
+   # $self->{'firstvalueonly'} = $firstvalueonly;
+   # $self->{'allvalues'} = $allvalues;
+
+    #$self->{'hlist_at_top'} = $hlist_at_top;
+
+    # Clean out the unused keys
+    delete $self->{'metadata'};
+    delete $self->{'hfile'};
     
     return bless $self, $class;
@@ -240,5 +222,5 @@
 	my $tempinfo = $self->get_OID_entry ($OID, $classifyinfo, $list->{$OID}->{'title'}, "VList");
 	
-	if (defined $self->{'sortname'}) {
+	if (defined $self->{'sort'}) {
 	    if ($self->{'reverse_sort'}) {
 		foreach $subOID (sort {$b->[1] cmp $a->[1];} @{$list->{$OID}->{'contents'}}) {
Index: /trunk/gsdl/perllib/classify/HTML.pm
===================================================================
--- /trunk/gsdl/perllib/classify/HTML.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/HTML.pm	(revision 10218)
@@ -54,29 +54,14 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
 
-    my ($title, $url);
-    
-    if (!parsargv::parse(\@_, 
-			 q^url/.*/^, \$url,
-			 q^buttonname/.*/Browse^, \$title,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    if (!$url) {
+    if (!$self->{'url'}) {
 	my $outhandle = $self->{'outhandle'};
 	print $outhandle "HTML Error: required option -url not supplied\n";
@@ -84,8 +69,4 @@
 	die "HTML Error: required option -url not supplied\n";
     }
-
-    $self->{'url'} = $url;
-    $self->{'title'} = $title;
-
     return bless $self, $class;
 }
@@ -107,5 +88,5 @@
     my %classifyinfo = ('thistype'=>'Invisible',
 			'childtype'=>'HTML',
-			'Title'=>$self->{'title'},
+			'Title'=>$self->{'buttonname'},
 			'contains'=>[]);
 
Index: /trunk/gsdl/perllib/classify/Hierarchy.pm
===================================================================
--- /trunk/gsdl/perllib/classify/Hierarchy.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/Hierarchy.pm	(revision 10218)
@@ -43,15 +43,15 @@
 my $arguments = 
     [ { 'name' => "separator",
-	'desc' => "{AutoHierarchy.separator}",
+	'desc' => "{Hierarchy.separator}",
 	'type' => "regexp",
 	'deft' => "[\\\\\\\/|\\\\\\\|]",
 	'reqd' => "no" },
       { 'name' => "suppresslastlevel",
-	'desc' => "{AutoHierarchy.suppresslastlevel}",
+	'desc' => "{Hierarchy.suppresslastlevel}",
 	'type' => "flag",
 	'reqd' => "no" } ];
 
 my $options = { 'name'     => "Hierarchy",
-		'desc'     => "{AutoHierarchy.desc}",
+		'desc'     => "{Hierarchy.desc}",
 		'abstract' => "no",
 		'inherits' => "yes",
@@ -60,35 +60,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new HFileHierarchy($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-
-    my $separator;
-    my $suppresslastlevel = 0;
-
-    if (!parsargv::parse(\@_, 
-			 q^separator/.*/^, \$separator,
-			 q^suppresslastlevel^, \$suppresslastlevel,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    
-    if (!$separator) {
-	$separator = "[\\\/|\\\|]";
-    }
-    $self->{'separator'} = $separator;
-    $self->{'suppresslastlevel'} = $suppresslastlevel;
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new HFileHierarchy($classifierslist,$inputargs,$hashArgOptLists): new HFileHierarchy($classifierslist,$inputargs); 
     
     # the hash that we use to build up the hierarchy
@@ -127,10 +104,12 @@
 	    push(@{$current_pos->{'docs'}}, $doc_OID);
 	} else {
-	    if (defined $sortmeta) {
-		# can you ever get the same doc twice in one classification??
-		$current_pos->{'docs'}->{$doc_OID} = $sortmeta;
-	    } else {
-		$current_pos->{'docs'}->{$doc_OID} = $metavalue;
-	    }
+	    $current_pos->{'docs'}->{$doc_OID} = $sortmeta;
+	    
+	    #if (defined $sortmeta) {
+	#	# can you ever get the same doc twice in one classification??
+	#	$current_pos->{'docs'}->{$doc_OID} = $sortmeta;
+	#    } else {
+	#	$current_pos->{'docs'}->{$doc_OID} = $metavalue;
+	#    }
 	}
     } # foreach metadata
@@ -146,8 +125,8 @@
     # are we sorting the list??
     my $nosort = 0;
-    if (defined $self->{'sortname'} && $self->{'sortname'} eq "nosort") {
+    if (!defined $self->{'sort'}) {
 	$nosort = 1;
     }
-
+    
     my $metavalues = [];
     # find all the metadata values
@@ -155,5 +134,5 @@
 	my $mvalues = $doc_obj->get_metadata($doc_obj->get_top_section(), $m);
 	next unless (@{$mvalues});
-	if ($self->{'onlyfirst'}) {
+	if ($self->{'firstvalueonly'}) {
 	    # we only want the first metadata value
 	    push (@$metavalues, $mvalues[0]);
@@ -169,12 +148,11 @@
     #check for a sort element other than our metadata
     my $sortmeta = undef;
-    if (!$nosort && defined $self->{'sortname'}) {
-	    
-	if ($self->{'sortname'} =~ /^filename$/i) {
+    if (!$nosort) {
+	if ($self->{'sort'} =~ /^filename$/i) {
 	    $sortmeta = $doc_obj->get_source_filename();
 	} else {
-	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sortname'});
+	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sort'});
 	    if (defined $sortmeta) {
-		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sortname'}, $sortmeta, $doc_obj);
+		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sort'}, $sortmeta, $doc_obj);
 	    }
 	}
@@ -252,7 +230,7 @@
 	my @doc_list;
 	# generate a sorted list of doc ids
-	if ($nosort && scalar(@{$top_hash->{$key}->{'docs'}})) {
+	if (not (defined ($self->{'sort'})) && scalar(@{$top_hash->{$key}->{'docs'}})) {
 	    @doc_list = @{$top_hash->{$key}->{'docs'}};
-	} elsif (!$nosort && (keys %{$top_hash->{$key}->{'docs'}})) {
+	} elsif (defined ($self->{'sort'}) && (keys %{$top_hash->{$key}->{'docs'}})) {
 	    @doc_list = sort {$top_hash->{$key}->{'docs'}->{$a} 
 			      cmp $top_hash->{$key}->{'docs'}->{$b};} keys %{$top_hash->{$key}->{'docs'}};
@@ -289,8 +267,8 @@
     if ($self->{'path_hash'}) {
 	if ($self->{'hlist_at_top'}) {
-	    $classification = $self->get_entry ($self->{'title'}, "HList", "Invisible");
+	    $classification = $self->get_entry ($self->{'buttonname'}, "HList", "Invisible");
 	}
 	else {
-	    $classification = $self->get_entry ($self->{'title'}, "VList", "Invisible");
+	    $classification = $self->get_entry ($self->{'buttonname'}, "VList", "Invisible");
 	}
     }
@@ -319,8 +297,8 @@
 
     if ($self->{'hlist_at_top'}) {
-	$classifyinfo = $self->get_entry ($self->{'title'}, "HList", "Invisible");
+	$classifyinfo = $self->get_entry ($self->{'buttonname'}, "HList", "Invisible");
     }
     else {
-	$classifyinfo = $self->get_entry ($self->{'title'}, "VList", "Invisible");
+	$classifyinfo = $self->get_entry ($self->{'buttonname'}, "VList", "Invisible");
     }
 
Index: /trunk/gsdl/perllib/classify/List.pm
===================================================================
--- /trunk/gsdl/perllib/classify/List.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/List.pm	(revision 10218)
@@ -44,10 +44,10 @@
   	'desc' => "{BasClas.buttonname}",
 	'type' => "string",
-	'deft' => "{BasClas.metadata.deft}",
+#	'deft' => "{BasClas.metadata.deft}",
 	'reqd' => "no" },
       { 'name' => "sort",
 	'desc' => "{List.sort}",
 	'type' => "string",
-	'deft' => "{BasClas.metadata.deft}",
+#	'deft' => "{BasClas.metadata.deft}",
 	'reqd' => "no" } ];
 
@@ -60,74 +60,59 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-
-    my ($metadata, $title, $sortname, $list);
-
-    if (!parsargv::parse(\@_, 
-			 q^metadata/.*/^, \$metadata,
-			 q^buttonname/.*/^, \$title,
-			 q^sort/.*/^, \$sortname,
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-    my @meta_list;
-    my $meta1;
-    
-    if ($metadata) {
-	@meta_list = split(/,/, $metadata);
+    my ($class) = shift (@_);
+
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
+
+    # Transfer value from Auto Parsing to the variable name that used in previous GreenStone.
+    my (@meta_list,$meta1);
+    print STDERR "new List\n";
+    if ($self->{"metadata"}) {
+	print STDERR "List: splitting metadata, ".$self->{"metadata"}."\n";
+	@meta_list = split(/,/, $self->{"metadata"});
 	$meta1 = $meta_list[0];
-    } else {
-	$metadata = undef;
+	$self->{'meta_list'} = \@meta_list;
+    } else {
 	$meta1=undef;
 	@meta_list = undef;
     }
 
-    if (!$title) {
-	if (defined ($meta1)) {
-	    $title = $meta1;
-	} else {
-	    $title = 'List';
-	}
-    }
-
-    # sortname is handled a bit differently - kjdon
+    if (!$self->{"buttonname"}) {
+	if (defined ($self->{'metadata'})) {
+	    $self->{"buttonname"} = $self->generate_title_from_metadata($self->{'metadata'});
+	} else {
+	    $self->{"buttonname"} = 'List';
+	}
+    }
+
+    # Further setup
+    # $self->{"sort"} is handled a bit differently - kjdon
     # undef means to sort, but use the metadata value from -metadata
     # because there is no one metadata value to get for sorting when 
     # we have a list of possible metadata
-    # to get no sorting, set sortname = 'nosort'
-    if (!$sortname) {
-	if (defined ($metadata)) {
-	    $sortname = undef;
-	} else {
-	    $sortname = "nosort";
-	}
-    }
+    # to get no sorting, set $self->{"sort"} = 'nosort'
+    if (!$self->{"sort"}) {
+	print STDERR "no sorting\n";
+	if (defined ($self->{"metadata"})) {
+	    $self->{"sort"} = undef;
+	    print STDERR "setting no meta\n";
+	} else {
+	    $self->{"sort"} = "nosort";
+	}
+    }    
+    if (defined  $self->{"sort"} &&  $self->{"sort"} eq "nosort") {
+	$self->{'list'} = [];
+    } else {
+	$self->{'list'} = {};
+    }
+        
+    # Clean out the unused keys
+    delete $self->{"metadata"}; # Delete this key
     
-    if (defined $sortname && $sortname eq "nosort") {
-	$list = [];
-    } else {
-	$list = {};
-    }
-    
-    $self->{'list'} = $list;
-    if (defined $metadata) {
-	$self->{'meta_list'} = \@meta_list;
-    }
-    $self->{'title'} = $title;
-    $self->{'sortname'} = $sortname;
-
     return bless $self, $class;
 }
@@ -146,5 +131,5 @@
     # are we sorting the list??
     my $nosort = 0;
-    if (defined $self->{'sortname'} && $self->{'sortname'} eq "nosort") {
+    if (defined $self->{'sort'} && $self->{'sort'} eq "nosort") {
 	$nosort = 1;
     }
@@ -195,12 +180,12 @@
 
     #check for a sort element other than our metadata
-    if (defined $self->{'sortname'}) {
+    if (defined $self->{'sort'}) {
 	my $sortmeta;
-	if ($self->{'sortname'} =~ /^filename$/i) {
+	if ($self->{'sort'} =~ /^filename$/i) {
 	    $sortmeta = $doc_obj->get_source_filename();
 	} else {
-	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sortname'});
+	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sort'});
 	    if (defined $sortmeta) {
-		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sortname'}, $sortmeta, $doc_obj);
+		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sort'}, $sortmeta, $doc_obj);
 	    }
 	}
@@ -225,5 +210,5 @@
 
     my @list = ();
-    if (defined $self->{'sortname'} && $self->{'sortname'} eq "nosort") {
+    if (defined $self->{'sort'} && $self->{'sort'} eq "nosort") {
 	@list = @{$self->{'list'}};
     } else {
@@ -233,8 +218,7 @@
 	}	
     }
-
     # organise into classification structure
     my %classifyinfo = ('childtype'=>'VList',
-			'Title'=>$self->{'title'},
+			'Title'=>$self->{'buttonname'},
 			'contains'=>[]);
     $classifyinfo{'thistype'} = 'Invisible' unless $no_thistype;
Index: /trunk/gsdl/perllib/classify/Phind.pm
===================================================================
--- /trunk/gsdl/perllib/classify/Phind.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/Phind.pm	(revision 10218)
@@ -150,17 +150,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasClas($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-	return bless $self, $class;
-    }
-
-    my $out = $self->{'outhandle'};
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasClas($classifierslist,$inputargs,$hashArgOptLists): new BasClas($classifierslist,$inputargs);
 
     # Ensure the Phind generate scripts are in place
@@ -168,44 +163,23 @@
     $file1 .= ".exe" if $ENV{'GSDLOS'} =~ /^windows$/;
     my $src = &util::filename_cat($ENV{'GSDLHOME'}, "src", "phind", "generate");
-
     if (!(-e $file1)) {
 	print STDERR "Phind.pm: ERROR: The Phind \"suffix\" program is not installed.\n\n";
 	exit(1);
     }
-
-    # Parse classifier arguments
-    my $builddir = "";
-    if (!parsargv::parse(\@_, 
-			 q^text/.*/section:Title,section:text^, \$self->{'indexes'},
-			 q^title/.*/Title^, \$self->{'titlefield'},
-			 q^buttonname/.*/Phrase^, \$self->{'buttonname'},
-			 q^language/.*/en^, \$language,
-			 q^savephrases/.*/^, \$self->{'savephrases'},
-			 q^suffixmode/\d/1^, \$self->{'suffixmode'},
-			 q^min_occurs/\d/2^, \$self->{'min_occurs'},
-			 q^thesaurus/.*/^, \$self->{'thesaurus'},
-			 q^untidy^, \$self->{'untidy'},
-			 "allow_extra_options")) {
-	
-	print STDERR "\nIncorrect options passed to $class, check your collect.cfg file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-    
-    # classifier information
-    $self->{'collection'} = $ENV{'GSDLCOLLECTION'};
-
-    # limit languages
-    $self->{'language_exp'} = $language;
-    
-    # collection directories
-    $self->{'collectiondir'} = $ENV{'GSDLCOLLECTDIR'};
-
+    
+    # Transfer value from Auto Parsing to the variable name that used in previous GreenStone.
+    $self->{"indexes"} = $self->{"text"};
+
+    # Further setup
+    $self->{'collection'} = $ENV{'GSDLCOLLECTION'}; # classifier information
+    $self->{'collectiondir'} = $ENV{'GSDLCOLLECTDIR'}; # collection directories
     if (! defined $self->{'builddir'}) {
 	$self->{'builddir'} = &util::filename_cat($ENV{'GSDLCOLLECTDIR'}, "building");
     } 
-
     $self->{'total'} = 0;
-   
+    
+    # Clean out the unused keys
+    delete $self->{"text"};
+
     return bless $self, $class;
 }
@@ -265,5 +239,5 @@
     my $top_section = $doc_obj->get_top_section();
 
-    my $titlefield = $self->{'titlefield'};
+    my $titlefield = $self->{'title'};
     
     my $title = $doc_obj->get_metadata_element ($top_section, $titlefield);
@@ -276,5 +250,5 @@
     # Only consider the file if it is in the correct language
     my $doclanguage = $doc_obj->get_metadata_element ($top_section, "Language");
-    my $phrlanguage = $self->{'language_exp'};
+    my $phrlanguage = $self->{'language'};
     return if ($doclanguage && ($doclanguage !~ /$phrlanguage/i));
     
@@ -282,5 +256,4 @@
     $self->{'total'} ++;
     print "file $self->{'total'}: $file\n" if ($self->{'$verbosity'});
-    
 
     # Store document details
@@ -698,5 +671,5 @@
     my $phinddir = $self->{'phinddir'};
 
-    my $language_exp = $self->{'language_exp'};
+    my $language_exp = $self->{'language'};
 
     my ($w, $l, $line, $word);
Index: /trunk/gsdl/perllib/classify/SectionList.pm
===================================================================
--- /trunk/gsdl/perllib/classify/SectionList.pm	(revision 10217)
+++ /trunk/gsdl/perllib/classify/SectionList.pm	(revision 10218)
@@ -45,16 +45,14 @@
 
 
-sub new {
-    my $class = shift (@_);
-    my $self = new List($class, @_);
+sub new { 
+    my ($class) = shift (@_);
+    my ($classifierslist,$inputargs,$hashArgOptLists) = @_;
+    push(@$classifierslist, $class);
 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
-    #if ($self->{'info_only'}) {
-	# created from classinfo.pl - don't need to parse the arguments
-    #	return bless $self, $class;
-    #}
+    my $self = (defined $hashArgOptLists)? new List($classifierslist,$inputargs,$hashArgOptLists): new List($classifierslist,$inputargs);
+
     return bless $self, $class;
 }
@@ -67,5 +65,5 @@
     # are we sorting the list??
     my $nosort = 0;
-    if (defined $self->{'sortname'} && $self->{'sortname'} eq "nosort") {
+    if (defined $self->{'sort'} && $self->{'sort'} eq "nosort") {
 	$nosort = 1;
     }
@@ -83,11 +81,11 @@
 
     my $sortmeta = "";
-    if (!$nosort && defined $self->{'sortname'}) {
-	if ($self->{'sortname'} =~ /^filename$/i) {
+    if (!$nosort && defined $self->{'sort'}) {
+	if ($self->{'sort'} =~ /^filename$/i) {
 	    $sortmeta = $doc_obj->get_source_filename();
 	} else {
-	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sortname'});
+	    $sortmeta = $doc_obj->get_metadata_element($doc_obj->get_top_section(), $self->{'sort'});
 	    if (defined $sortmeta) {
-		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sortname'}, $sortmeta, $doc_obj);
+		$sortmeta = &sorttools::format_metadata_for_sorting($self->{'sort'}, $sortmeta, $doc_obj);
 	    }
 	}
@@ -140,9 +138,9 @@
     } 
 
-    if (defined $self->{'sortname'}) {
+    if (defined $self->{'sort'}) {
 	# sorting on alternative metadata
 	$self->{'list'}->{"$doc_OID.$section"} = $sortmeta;
     } else {
-	# sortingon the classification metadata
+	# sorting on the classification metadata
 	# do the same formatting on the meta value as for sort meta
 	$metavalue = &sorttools::format_metadata_for_sorting($metaname, $metavalue, $doc_obj);
Index: /trunk/gsdl/perllib/plugin.pm
===================================================================
--- /trunk/gsdl/perllib/plugin.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugin.pm	(revision 10218)
@@ -84,5 +84,5 @@
 	$options =~ s/\$/\\\$/g;
 
-	eval ("\$plugobj = new \$pluginname($options)");
+	eval ("\$plugobj = new \$pluginname([],[$options])");
 	die "$@" if $@;
 	
Index: /trunk/gsdl/perllib/plugins/ArcPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ArcPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ArcPlug.pm	(revision 10218)
@@ -53,10 +53,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("ArcPlug", @_);
-	 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-	 my $option_list = $self->{'option_list'};
-	 push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){print "SETSEGE\n"; push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/BNContentePlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/BNContentePlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/BNContentePlug.pm	(revision 10218)
@@ -39,5 +39,5 @@
 
 sub BEGIN {
-    @ISA = ('BasPlug');
+    @BNContentePlug::ISA = ('BasPlug');
     unshift (@INC, "$ENV{'GSDLHOME'}/perllib/cpan");
 }
@@ -93,20 +93,12 @@
 
 sub new {
-    my $class = shift (@_);
-    #my $plugin_name = shift (@_);
-
-    $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "BNContentePlug";
-
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
- 
-    if (!parsargv::parse(\@_,
-			 "allow_extra_options")) {
-	print STDERR "\nBNContentePlug uses an incorrect option.\n";
-	print STDERR "Check your collect.cfg configuration file.\n\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
     
     #create XML::Parser object for parsing metsHTML.xml, NCB_???.xml files
